<?php
// prevent direct calls to this file from doing anything.
if(!defined('ABSPATH') || !defined('WPINC'))
{
	die();
}

class PNDL_FeaturedProductPlugin
{
	private $pluginFile;
	private $wpdb;

	private function __construct($pluginFile)
	{
		global $wpdb;

		$this->pluginFile = $pluginFile;
		$this->wpdb = $wpdb;
	}

	public static function create($pluginFile)
	{
		// instantiate the plugin
		$localPlugin = new PNDL_FeaturedProductPlugin($pluginFile);

		// configure hooks
		if (is_admin())
		{
			// note that we're using "/" instead of DIRECTORY_SEPARATOR - it would appear that wordpress has the plugin
			// name registered using "/" regardless of platform.
			$pluginName = basename(dirname($pluginFile)) . "/" . basename($pluginFile);
			add_action("after_plugin_row_$pluginName", array($localPlugin, 'after_plugin_row'));
		}

		add_action('widgets_init', array($localPlugin, "widgets_init"));
	}

	public function after_plugin_row($arg1)
	{
		if (!function_exists('wpsc_product_url'))
		{
			echo "<tr><td/><td/><td><strong>Warning:</strong> This plugin works with the \"WP e-Commerce\" plugin, which has not been detected on your installation. The widgets associated with this plugin will therefore not appear as expected.<td></tr>\n";
		}
	}

	public function widgets_init()
	{
		require_once 'featuredproduct_widget.php';
		register_widget('PNDL_FeaturedProductWidget');
	}
}
?>